Description

If we are using multiple refinements for the Kernel module, it seems that only the last refinement is enabled.

In the following example, we can call f2 of M2, which is enabled later. but cannot call f1 of M1.

module M1

  refine(Kernel) do

    def f1 = :f1

  end

end

module M2

  refine(Kernel) do

    def f2 = :f2

  end

end

class Foo

  using M1

  using M2

  def test

    p f2 #=> :f2

    p f1 # expected => :f1

         # actual => undefined local variable or method 'f1' for an instance of Foo

  end

end

Foo.new.test

 Note that if I change refine(Kernel) to refine(Object), it works as expected.

So I think there is a problem only when the refinement target is a module.

Associated revisions

Revision d50f9ca2dd416d92152cd958b5f39496088481b0 - 02/27/2024 05:51 AM - shugo (Shugo Maeda)

[Bug #20302] Multiple refinements cannot be applied to the same module

In the following code, the iclass tree of refinements in cref should be <iclass of Kernel@M2> -> <iclass of Kernel@M1> -> Kernel.

However, the iclass tree was broken because of code for included modules of refinements in rb_using_refinement().

Refinement#include is now removed, so this commit removes such unnecessary code.

module M1

  refine(Kernel) do

    def f1 = :f1

  end

end

module M2

  refine(Kernel) do

    def f2 = :f2

  end

end
class Foo

  using M1

  using M2

  def test

    p f2 #=> :f2

    p f1 # expected => :f1

         # actual => undefined local variable or method 'f1' for an instance of Foo

  end

end

Foo.new.test

Revision d50f9ca2dd416d92152cd958b5f39496088481b0 - 02/27/2024 05:51 AM - shugo (Shugo Maeda)

[Bug #20302] Multiple refinements cannot be applied to the same module

In the following code, the iclass tree of refinements in cref should be <iclass of Kernel@M2> -> <iclass of Kernel@M1> -> Kernel.

However, the iclass tree was broken because of code for included modules of refinements in rb_using_refinement().

Refinement#include is now removed, so this commit removes such unnecessary code.

module M1

  refine(Kernel) do

    def f1 = :f1

  end

end

module M2

  refine(Kernel) do

    def f2 = :f2

  end

end

class Foo

  using M1

  using M2

  def test

    p f2 #=> :f2

    p f1 # expected => :f1

         # actual => undefined local variable or method 'f1' for an instance of Foo

  end

end

Foo.new.test

Revision d50f9ca2 - 02/27/2024 05:51 AM - shugo (Shugo Maeda)

[Bug #20302] Multiple refinements cannot be applied to the same module

In the following code, the iclass tree of refinements in cref should be <iclass of Kernel@M2> -> <iclass of Kernel@M1> -> Kernel.

However, the iclass tree was broken because of code for included modules of refinements in rb_using_refinement().

Refinement#include is now removed, so this commit removes such unnecessary code.

module M1

  refine(Kernel) do

    def f1 = :f1

  end

end

module M2

  refine(Kernel) do

    def f2 = :f2

  end

end

class Foo

  using M1

  using M2
  def test

    p f2 #=> :f2

    p f1 # expected => :f1

         # actual => undefined local variable or method 'f1' for an instance of Foo

  end

end

Foo.new.test

History

#1 - 02/27/2024 05:51 AM - shugo (Shugo Maeda)

- Status changed from Open to Closed

Applied in changeset git|d50f9ca2dd416d92152cd958b5f39496088481b0.

[Bug #20302] Multiple refinements cannot be applied to the same module

In the following code, the iclass tree of refinements in cref should be <iclass of Kernel@M2> -> <iclass of Kernel@M1> -> Kernel.

However, the iclass tree was broken because of code for included modules of refinements in rb_using_refinement().

Refinement#include is now removed, so this commit removes such unnecessary code.

module M1

  refine(Kernel) do

    def f1 = :f1

  end

end

module M2

  refine(Kernel) do

    def f2 = :f2

  end

end

class Foo

  using M1

  using M2

  def test

    p f2 #=> :f2

    p f1 # expected => :f1

         # actual => undefined local variable or method 'f1' for an instance of Foo

  end

end

Foo.new.test

Powered by TCPDF (www.tcpdf.org)

06/26/2025 3/3

https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/d50f9ca2dd416d92152cd958b5f39496088481b0
https://bugs.ruby-lang.org/issues/20302
http://www.tcpdf.org

